unit frmmain;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, jsonparser,
  csvdataset, DB, fpmustache, dbgrids, DBCtrls;

type

  { TMainForm }

  TMainForm = class(TForm)
    BRender: TButton;
    dsFamily: TDataSource;
    csvFamily: TCSVDataset;
    NavData: TDBNavigator;
    lblTemplate: TLabel;
    lblJSON: TLabel;
    lblResult: TLabel;
    MTemplate: TMemo;
    GData: TDBGrid;
    MResult: TMemo;
    procedure BRenderClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    FMustache: TMustache;
  public
  end;

var
  MainForm: TMainForm;

implementation

uses fpdbmustache;

{$R *.lfm}

{ TMainForm }

procedure TMainForm.BRenderClick(Sender: TObject);

Var
  C : TMustacheDBContext;

begin
  C:=TMustacheDBContext.Create(Nil);
  try
    C.AddDataset(csvFamily,'data');
    C.StaticValues.Values['title']:='Our family';
    fMustache.Template:=mTemplate.Text;
    MResult.Text:=fMustache.Render(C);
  finally
    C.Free;
  end;
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
  FMustache:=TMustache.Create(Self);
  csvFamily.FileName:=ExtractFilePath(ParamStr(0))+'family.csv';
  csvFamily.Open;
end;

end.

